#
# spec file for package heartbeat (Version 0.4.8i)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  lynx openssl
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz lynx m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openssl pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         heartbeat
%define version 0.4.8i
Version:      0.4.8i
Release:      118
Group:        Applications/Clustering
Copyright:    GPL
Summary:      heartbeat subsystem for High-Availability Linux
URL:          http://linux-ha.org/
Source0:      http://linux-ha.org/download/heartbeat-%{version}.tar.gz
Patch0:       heartbeat-%{version}.dif
Buildroot:    %{_tmppath}/heartbeat-root

%description
heartbeat is a basic heartbeat subsystem for Linux-HA.
It will run scripts at initialization, and when machines go up or down.
This version will also perform IP address takeover using gratuitious ARPs.
It works correctly for a 2-node configuration, and is extensible to larger
configurations.
It implements the following kinds of heartbeats:
- Bidirectional Serial Rings ("raw" serial ports)
- UDP/IP braodcast (ethernet, etc)
- Bidirectional Serial PPP/UDP Rings (using PPP)

Authors:
--------
    Alan Robertson <alanr@suse.com>
    Volker Wiegand <Volker.Wiegand@suse.de>
    Rudy Pawul <rpawul@iso-ne.com>
    Mitja Sarp <mitja@lysator.liu.se>
    Guenther Thomsen <thomsen@cs.tu-berlin.de>
    Jacob Rief <jacob.rief@tis.at>
    Luis Claudio R. Gonalves <lclaudio@conectiva.com.br>
    Marcelo Tosatti <marcelo@conectiva.com.br>
    Horms <horms@vergenet.net>

SuSE series: ap

%package ldirectd
Summary:      Monitor daemon for maintaining high availability resources
Group: Applications/Clustering
# These are the right perl module names, but the wrong package names.
# Requires: LWP.pm, Net::SSLeay get yours from ultramonkey.sourceforge.net
Requires: perl-Net_SSLeay perl-libwww-perl

%description ldirectd
The Linux Director Daemon (ldirectord) was written by Jacob Rief
<jacob.rief@tiscover.com>
The ldirectord is a stand-alone daemon to monitor services of real
servers, currently http, https and ftp service. It is simple to
install and works with the heartbeat code (http://www.linux-ha.org/).
See 'ldirectord -h' for all the information about ldirectord.
See linux-ha/doc/ldirectord for more information.

Authors:
--------
    Jacob Rief <jacob.rief@tiscover.com>

SuSE series: ap

%package stonith
Summary:      Provides an interface to Shoot The Other Node In The Head
Group: Applications/Clustering

%description stonith
The STONITH module (a.k.a. STOMITH) provides an extensible interface
for remotely powering down a node in the cluster.  The idea is quite simple:
When the software running on one machine wants to make sure another
machine in the cluster is not using a resource, pull the plug on the other
machine. It's simple and reliable, albiet admittedly brutal.

Authors:
--------
    Alan Robertson <alanr@suse.com>

SuSE series: ap

%prep
%setup -n heartbeat-%{version}
%patch0

%build
make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
RPM_BUILD=yes BUILD_ROOT=$RPM_BUILD_ROOT MAN_DIR=$RPM_BUILD_ROOT/%{_mandir} \
	make -e install
ln -s ./init.d/heartbeat  $RPM_BUILD_ROOT/sbin/rcheartbeat
ln -s ./init.d/ldirectord $RPM_BUILD_ROOT/sbin/rcldirectord
ln -s ../../../sbin/ldirectord $RPM_BUILD_ROOT/etc/ha.d/resource.d/ldirectord
TEMPL=$RPM_BUILD_ROOT/var/adm/fillup-templates
[ -d $TEMPL ] || mkdir -p $TEMPL
install -m 644 rc.config.heartbeat $TEMPL/rc.config.heartbeat

%files
%defattr(-,root,root)
%dir /etc/ha.d
/etc/ha.d/harc
/etc/ha.d/shellfuncs
/etc/ha.d/rc.d
/etc/ha.d/conf
/etc/ha.d/README.config
/usr/lib/heartbeat
/usr/lib/libhbclient.so
/usr/lib/libhbclient.a
/etc/ha.d/resource.d
/etc/logrotate.d/heartbeat
/sbin/rcheartbeat
%config /etc/init.d/heartbeat
/var/adm/fillup-templates/rc.config.heartbeat
%dir /var/run/ppp.d
%dir /var/lib/heartbeat
%attr (600, root,  root)     /var/lib/heartbeat/fifo
%attr (750, root,  haclient) /var/lib/heartbeat/api
%attr (620, root,  haclient) /var/lib/heartbeat/register
%attr (1770, root, haclient) /var/lib/heartbeat/casual
%doc doc/*

%files ldirectd
/sbin/ldirectord
/etc/logrotate.d/ldirectord
/sbin/rcldirectord
%config /etc/init.d/ldirectord
%doc %{_mandir}/man8/ldirectord.8*
%doc ldirectord/ldirectord.cf

%files stonith
/usr/lib/libstonith.a
/usr/lib/libstonith.so
%dir /usr/lib/stonith
/usr/lib/stonith/*.so
/usr/sbin/stonith
/usr/include/stonith.h
#%clean
#rm -rf $RPM_BUILD_ROOT
#rm -rf $RPM_BUILD_DIR/heartbeat-0.4.8

%pre
if
  grep '^haclient:' etc/group >/dev/null
then
  : OK group haclient already present
else
  GROUPOPT="-g 65"
  if
    chroot . /usr/sbin/groupadd $GROUPOPT haclient
  then
    : OK we were able to add group haclient
  else
    chroot . /usr/sbin/groupadd haclient
  fi
fi

%post
#
#	Hack to allow ppp-udp to be notified about PPP processes starting
#
Install_PPP_hack() {
  file2hack=etc/ppp/ip-up.local
  echo "NOTE: Modifying $file2hack"
  if [ ! -f $file2hack ] ; then
    echo '#!/bin/bash' > $file2hack
    chmod 755 $file2hack
  fi
  MARKER="Heartbeat"
  ed -s $file2hack <<-!EOF  2>/dev/null
H
g/ $MARKER\$/d
\$a
# The following lines added for Linux-HA support             # $MARKER
DEVFILE=\`echo \$DEVICE | sed -e 's!^/dev/!!' -e 's!/!.!g'\` # $MARKER
OUTFILE=/var/run/ppp.d/\$DEVFILE                             # $MARKER
(                    # $MARKER
echo "\$IPREMOTE"    # $MARKER
echo "\$IFNAME"      # $MARKER
echo "\$PPPD_PID"    # $MARKER
echo "\$IPLOCAL"     # $MARKER
) > \$OUTFILE        # $MARKER
.
w
!EOF
}
if [ ! -x etc/ppp/ip-up.heart ] ; then
  Install_PPP_hack
fi
if [ -x sbin/insserv ] ; then
	# LSB: Create symbolic run level links
	sbin/insserv etc/init.d/
else
  for d in etc/rc.d/init.d/rc[23].d ; do
    rm -f $d/S10heartbeat
    rm -f $d/S99heartbeat; ln -s ../heartbeat $d/S99heartbeat
    rm -f $d/K35heartbeat; ln -s ../heartbeat $d/K35heartbeat
  done
fi
echo "Updating etc/rc.config..."
if [ -x bin/fillup ] ; then
	bin/fillup -q -d = etc/rc.config var/adm/fillup-templates/rc.config.heartbeat
else
  echo "ERROR: fillup not found. This should not happen. Please compare"
  echo "/etc/rc.config and /var/adm/fillup-templates/rc.config.heartbeat"
  echo "and update by hand."
fi
true

%preun
Uninstall_PPP_hack() {
  file2hack=etc/ppp/ip-up.local
  echo "NOTE: Restoring $file2hack"
  MARKER="Heartbeat"
  ed -s $file2hack <<-!EOF  2>/dev/null
H
g/ $MARKER\$/d
w
!EOF
}
if [ $1 = 0 ] ; then
  [ -x sbin/chkconfig ] && sbin/chkconfig --del heartbeat
  if [ ! -x etc/ppp/ip-up.heart ] ; then
    Uninstall_PPP_hack
  fi
fi
true

%postun
if [ -x sbin/insserv ] ; then
	# LSB: Rearrange run level symlinks after removing the init script
	sbin/insserv etc/init.d/
else
 	rm -f sbin/init.d/rc{2,3}/*heartbeat
 	rm -f usr/sbin/rcheartbeat
fi
true

%changelog -n heartbeat
* Thu Sep 20 2001 - jg@suse.de
- added buildroot fixes from HBV
* Tue Feb 20 2001 - uli@suse.de
- fixed for new glibc
* Thu Jan 18 2001 - ro@suse.de
- next occurence of old gid
* Thu Jan 18 2001 - ro@suse.de
- changed gid to 65 all over
* Tue Jan 16 2001 - ro@suse.de
- changed group-id to 65 (60 is already used)
* Tue Jan 16 2001 - mt@suse.de
- deleted '' characters in spec file
* Tue Dec 19 2000 - uli@suse.de
- added openssl to neededforbuild (needed by lynx)
* Fri Dec 01 2000 - ro@suse.de
- init-script move to /etc/init.d
* Wed Nov 22 2000 - mt@suse.de
- changed to LSB installation of run level scripts
* Fri Nov 17 2000 - mt@suse.de
- updated to newest version 0.4.8i
* Wed Nov 15 2000 - mt@suse.de
- updated to newest version 0.4.8h
* Wed Nov 08 2000 - mt@suse.de
- added patch to not to install docs from makefile - rpm does it
* Wed Nov 08 2000 - mt@suse.de
- new package
